includeLibrary( "/OpenForum/Javascript/DragAndDrop/drag-and-drop.js" );
includeLibrary( "/OpenForum/Javascript/DragAndDrop/line.js" );
includeLibrary( "/OpenForum/Javascript/mouse.js" );
includeLibrary( "/OpenForum/Javascript/ajax.js" );
includeLibrary( "/OpenForum/Javascript/xml.js" );


includeInitFunction( "initStickyArrows();" );
includeUnloadFunction( "unloadStickyArrows();" );

var movers = new Array();
var lines = new Array();

function addArrow(xStart,yStart,xEnd,yEnd)
{
  newLine = new Arrow(xStart,yStart,0,0,"StickyArrowsCanvas");
  newLine.setStart( xStart,yStart );
  newLine.setEnd( xEnd,yEnd );
  lines[lines.length] = newLine;

  index = movers.length;
  data = fileManager.loadFile("/OpenForum/Extensions/StickyArrows","move.html.template");
  data = data.replace(/&index;/g,index);
  data = data.replace(/&id;/g,"movers");

  newElement = document.createElement("div");
  newElement.setAttribute('id',"movers"+index);  
  newElement.style.position="absolute";
  newElement.style.zIndex=100;
  newElement.style.left=xEnd;
  newElement.style.top=yEnd;
  newElement.innerHTML=data;
  document.getElementById("StickyArrowsCanvas").appendChild(newElement);
   movers[movers.length] = new DragAndDropObject("movers"+movers.length);

  index = movers.length;
  data = fileManager.loadFile("/OpenForum/Extensions/StickyArrows","move.html.template");
  data = data.replace(/&index;/g,index);
  data = data.replace(/&id;/g,"movers");

  newElement = document.createElement("div");
  newElement.setAttribute('id',"movers"+index);  
  newElement.style.position="absolute";
  newElement.style.zIndex=100;
  newElement.style.left=xStart;
  newElement.style.top=yStart;
  newElement.innerHTML=data;
  document.getElementById("StickyArrowsCanvas").appendChild(newElement);
  movers[movers.length] = new DragAndDropObject("movers"+movers.length);
  movers[movers.length-1].setPosition(xStart,yStart);

  movers[movers.length-1].attach( newLine,"setStart" );
  movers[movers.length-1].setPosition(xStart,yStart);
  movers[movers.length-2].attach( newLine,"setEnd" );
  movers[movers.length-2].setPosition(xEnd,yEnd);

  return movers[movers.length-1];
}

var stickiesInitialised = false;
function initStickyArrows()
{
 try{
  loadStickyArrows();

  stickiesInitialised = true;
 }
 catch(e)
 {
    ui.showAlert("Sticky Problem","Sticky Arrows failed to initialise.\nSticky Arrows will not be saved.\nError: "+e+" at line "+e.lineNumber);
 }
}

function unloadStickyArrows()
{
  if(stickiesInitialised==true)
  {
    saveStickyArrows();
  }
}

function saveStickyArrows()
{
  arrowsXml = new XmlElement("arrows");

  for(loop=0;loop<lines.length;loop++)
  {
    arrowXml = arrowsXml.addChild("arrow");   
    arrowXml.addAttribute( "x1",lines[loop].xStart  );
    arrowXml.addAttribute( "y1",lines[loop].yStart  );
    arrowXml.addAttribute( "x2",lines[loop].xEnd  );
    arrowXml.addAttribute( "y2",lines[loop].yEnd  );
    
  }
  
//alert(arrowsXml.toString());
  fileManager.saveFile("/"+pageName,"sticky-arrows.xml", arrowsXml.toString());
}

function loadStickyArrows()
{
  if( fileManager.fileExists("/"+pageName,"sticky-arrows.xml")==false )
  {
    return;
  }

  data = ajax.doGet( "/OpenForum/Actions/GetXmlFileAsJS","pageName=/"+pageName+"&fileName=sticky-arrows.xml&varName=arrowsXml" );
//alert(data);
  eval(data);

  for(loopX=0;loopX<arrowsXml.children.length;loopX++)
  {
   arrowXml= arrowsXml.children[loopX];
   x1 = new Number( arrowXml.getAttributeValue("x1") );
   y1 = new Number( arrowXml.getAttributeValue("y1") );
   x2 = new Number( arrowXml.getAttributeValue("x2") );
   y2 = new Number( arrowXml.getAttributeValue("y2") );

   addArrow(x1,y1,x2,y2);
  }
//alert("Init done for "+notesXml.children.length);
}