includeLibrary( "/OpenForum/Javascript/DragAndDrop/drag-and-drop.js" );
includeLibrary( "/OpenForum/Javascript/mouse.js" );
includeLibrary( "/OpenForum/Javascript/ajax.js" );
includeLibrary( "/OpenForum/Javascript/xml.js" );

includeInitFunction( "initStickyNotes();" );
includeUnloadFunction( "unloadStickyNotes();" );

var stickiesInitialised = false;
var stickies = new Array();

function initStickyNotes()
{
 try{
  loadStickies();

  stickiesInitialised = true;
 }
 catch(e)
 {
    ui.showAlert("Sticky Problem","Stickies failed to initialised.\nStickies will not be saved.");
 }
}

function addSticky(x,y,value)
{
  index = stickies.length;

  data = fileManager.loadFile("/OpenForum/Extensions/StickyNotes","sticky.html.template");
  data = data.replace(/&index;/g,index);
  data = data.replace(/&value;/g,renderText(value));
  newElement = document.createElement("div");
  newElement.setAttribute('id',"sticky"+index);  
  newElement.style.position="absolute";
  newElement.style.zIndex=100;
  newElement.style.top = y;
  newElement.style.left = x;
  newElement.innerHTML=data;
  document.getElementById("StickyNotesCanvas").appendChild(newElement);
  sticky = new DragAndDropObject("sticky"+index);
  stickies[index] = sticky;
  sticky.setEditMode = function()
  {
    this.note=document.getElementById( this.objName+"Note" );
    this.note.value = this.text;
    this.size = getTextAreaSize(this.text);
    this.note.cols = this.size[0];
    this.note.rows = this.size[1];

    document.getElementById( this.objName+"Edit" ).style.display="block";
    document.getElementById( this.objName+"View" ).style.display="none";
    return false;
  }
  sticky.setViewMode = function()
  {
    this.text = document.getElementById( this.objName+"Note" ).value;
    document.getElementById( this.objName+"ViewNote" ).innerHTML = renderText(this.text);

    document.getElementById( this.objName+"Edit" ).style.display="none";
    document.getElementById( this.objName+"View" ).style.display="block";
    return false;
  }
  sticky.deleteSelf = function()
  {
      document.getElementById( this.objName ).style.display="none";
      this.deleted = true;
  }
  sticky.text=value;
  return sticky;
}

function unloadStickyNotes()
{
  if(stickiesInitialised==true)
  {
    saveStickies();
  }
}

function saveStickies()
{
  notesXml = new XmlElement("notes");

  for(loop=0;loop<stickies.length;loop++)
  {
    if(stickies[loop].deleted==true)
    {
      continue;
    }
    noteXml = notesXml.addChild("note");
    
    value = document.getElementById(stickies[loop].objName+"Note").value;
    
    noteXml.setValue( value );
    noteXml.addAttribute( "x",stickies[loop].x  );
    noteXml.addAttribute( "y",stickies[loop].y  );
    
  }
  
  fileManager.saveFile("/"+pageName,"sticky-notes.xml", notesXml.toString());
//alert("Stickies saved to /"+pageName,"sticky-notes.xml");
}

function loadStickies()
{
  if( fileManager.fileExists("/"+pageName,"sticky-notes.xml")==false )
  {
    return;
  }

  data = ajax.doGet( "/OpenForum/Actions/GetXmlFileAsJS","pageName=/"+pageName+"&fileName=sticky-notes.xml&varName=notesXml" );
//alert(data);
  eval(data);
  for(loopX=0;loopX<notesXml.children.length;loopX++)
  {
   noteXml = notesXml.children[loopX];
   x = new Number( noteXml.getAttributeValue("x") );
   y = new Number( noteXml.getAttributeValue("y") );
   value = noteXml.getValue();

   addSticky(x,y,value);
  }
//alert("Init done for "+notesXml.children.length);
}

function renderText(text)
{
  return ajax.doGet("/OpenForum/Actions/RenderWikiData","pageName=/"+pageName+"&data="+text);
}

function getTextAreaSize(text)
{
  text = text.split("\n");
  y=text.length+1;
  x=0;
  for(loop=0;loop<text.length;loop++)
  {
    if(text[loop].length>x)
    {
      x = text[loop].length;
    }
  }
  if(x<20)
  {
    x=20;
  }
  if(y<5)
  {
    y=5;
  }

  return [x,y];
}