package org.one.stone.soup.browser;

import java.net.*;

import java.util.Hashtable;
import java.util.Properties;
import java.io.*;

import org.one.stone.soup.file.*;


/**
 * @author nikcross
 *
 */

// TODO
public class Browser {
	private static ResourceStore resourceStore;

	private static String flavour;
	private static boolean isApplet = false;
	private static ProgressListener progressListener = null;
	
	
	
private Browser() {
	super();
}
public static void downloadResource(String url, String file)
{
 long size = 0;
 try{
	InputStream iStream = new URL(url).openStream();
	FileOutputStream oStream = new FileOutputStream(file);

	int in = iStream.read();

	while(in!=-1)
	{
		oStream.write((char)in);
		size++;

		in = iStream.read();
	}

	iStream.close();
	oStream.close();
 }
 catch(Exception e)
 {
	 e.printStackTrace();
 }

 System.out.println("Downloaded Url:"+url+" to File:"+file+" size="+size);
}
/**
 *
 * @return java.lang.String
 */
public static String getBase() {
	return BrowserURLFactory.getBase();
}
public static InputStream getInputStream(String url) throws MalformedURLException,IOException
{
	return BrowserURLFactory.getURLInputStream(flavour,url,flavour,isApplet);
}

/**
 *
 * @return org.one.stone.soup.file.ProgressListener
 */
private static ProgressListener getProgressListener() {
	return progressListener;
}
public static Object getResource(String url)
{
	if(resourceStore!=null)
	{
		return resourceStore.retrieve(url);
	}
	else
	{
		return null;
	}
}
public static String getURLFor(String url) throws MalformedURLException
{
	return BrowserURLFactory.getURL(url);
}
public static void initialize(boolean applet,String newFlavour)
{
	flavour = newFlavour;
	isApplet = applet;
}

public static OutputStream openURLPostFileStream(String url,String fileName) throws MalformedURLException,IOException
{
	return new BrowserFileOutputStream( BrowserURLFactory.openURLPostFileConnection(flavour,url),fileName );	
}

protected static void closeURLPostFileConnection(URLConnection connection,OutputStream outputStream) throws MalformedURLException,IOException
{
	BrowserURLFactory.closeURLPostFileConnection(connection,outputStream);
}

public static InputStream postFile(String url,String fileName) throws MalformedURLException,IOException
{
	InputStream fileStream = new FileInputStream(fileName);

//	String ext = FileHelper.getExt(fileName);
//	String type = org.one.stone.soup.net.MimeType.getType(ext);

	return BrowserURLFactory.getURLPostFile(flavour,url,new File(fileName).getName(),fileStream);
}
public static InputStream postForm(String url,Hashtable data) throws MalformedURLException,IOException
{
	return BrowserURLFactory.getURLPost(flavour,url,data);
}
public static InputStream setBaseURL(String url) throws IOException
{
	InputStream iStream = BrowserURLFactory.setBase(url,flavour,progressListener,isApplet);
	return iStream;
}
/**
 *
 * @param newProgressListener org.one.stone.soup.file.ProgressListener
 */
public static void setProgressListener(ProgressListener newProgressListener) {
	progressListener = newProgressListener;
}

public static boolean hasResourceStore()
{
	if(resourceStore==null)
	{
		return false;
	}
	return true;
}
public static void setResourceStore(ResourceStore newResourceStore)
{
	if(resourceStore==null)
	{
		resourceStore = newResourceStore;
	}
}
public static void storeResource(String key,Object resource)
{
	if(resourceStore!=null)
	{
		resourceStore.store(key,resource);
	}
}

public static void setProxy(String host,int port)
{
	Properties systemSettings = System.getProperties();
	systemSettings.put("proxyHost", host);
	systemSettings.put("proxyPort", ""+port);
	
	setUseProxy(true);
}

public static void setUseProxy(boolean state)
{
	Properties systemSettings = System.getProperties();
	systemSettings.put("proxySet", ""+state);	
}

public static String getFlavour()
{
	return flavour;
}

}
