package org.one.stone.soup.wiki.upload.applet;

import java.awt.Component;
import java.awt.datatransfer.DataFlavor;
import java.awt.dnd.DnDConstants;
import java.awt.dnd.DropTarget;
import java.awt.dnd.DropTargetListener;
import java.util.Vector;

	/**
	 * Insert the type's description here.
	 * Creation date: (17/05/03 12:22:11)
	 * @author:
	 */
	public class AppletDropReceiver implements DropTargetListener
	{
		private UploadApplet receiver;
		private DropTarget dropTarget;
	/**
	 * XDropReceiver constructor comment.
	 */
	public AppletDropReceiver(Component target,UploadApplet receiver) {
		super();

		this.receiver = receiver;

		dropTarget = new DropTarget(target,this);
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (11/06/03 12:35:31)
	 */
	public void dispose()
	{
		dropTarget.setActive(false);
		dropTarget=null;
		receiver = null;
	}
		/**
		 * Called when a drag operation has
		 * encountered the <code>DropTarget</code>.
		 * <P>
		 * @param dtde the <code>DropTargetDragEvent</code>
		 */
	public void dragEnter(java.awt.dnd.DropTargetDragEvent dtde) {}
		/**
		 * The drag operation has departed
		 * the <code>DropTarget</code> without dropping.
		 * <P>
		 * @param dte the <code>DropTargetEvent</code>
		 */
	public void dragExit(java.awt.dnd.DropTargetEvent dte) {}
		/**
		 * Called when a drag operation is ongoing
		 * on the <code>DropTarget</code>.
		 * <P>
		 * @param dtde the <code>DropTargetDragEvent</code>
		 */
	public void dragOver(java.awt.dnd.DropTargetDragEvent dtde) {}
		/* (non-Javadoc)
		 * @see org.one.stone.soup.xapp.dnd.XappDropReceiver#drop(java.awt.dnd.DropTargetDropEvent)
		 */
	public void drop(java.awt.dnd.DropTargetDropEvent dtde)
	{
		DataFlavor flavor = null;
		if( dtde.getTransferable().isDataFlavorSupported(DataFlavor.javaFileListFlavor) )
		{
			flavor = DataFlavor.javaFileListFlavor;
		}

		if(flavor==null)
		{
			return;
		}

		try{
			dtde.acceptDrop(DnDConstants.ACTION_COPY);

			if( flavor.equals(DataFlavor.javaFileListFlavor) )
			{
				java.util.List list = (java.util.List)dtde.getTransferable().getTransferData( java.awt.datatransfer.DataFlavor.javaFileListFlavor );

				String[] fileList = new String[list.size()];

				for(int loop=0;loop<list.size();loop++)
				{
					String fileName = list.get(loop).toString();

					fileList[loop]=fileName;
				}

				dtde.dropComplete(true);

				receiver.receiveFileList(fileList);

			}
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
	}
		/**
		 * Called if the user has modified
		 * the current drop gesture.
		 * <P>
		 * @param dtde the <code>DropTargetDragEvent</code>
		 */
	public void dropActionChanged(java.awt.dnd.DropTargetDragEvent dtde) {}
	/* (non-Javadoc)
	 * @see org.one.stone.soup.xapp.dnd.XappDropReceiver#getDropTarget()
	 */
	public Component getDropTarget() {
		return dropTarget.getComponent();
	}
	/* (non-Javadoc)
	 * @see org.one.stone.soup.xapp.dnd.XappDropReceiver#setDropTarget(java.awt.Component)
	 */
	public void setDropTarget(Component target) {
		dropTarget = new DropTarget(target,this);
	}
}
