package org.one.stone.soup.xml.stream;

import java.io.*;
import java.util.Hashtable;

import org.one.stone.soup.util.*;
import org.one.stone.soup.xml.*;

/*
 * Wet-Wired.com Xml Version Date 25-Aug-2004
 *
 * Copyright 2000-2001 by Wet-Wired.com Ltd.,
 * Portsmouth England
 * This software is OSI Certified Open Source Software
 * This software is covered by an OSI approved open source licence
 * which can be found at http://www.onestonesoup.org/OSSLicense.html
 */

/**
 * @author nikcross
 *
 */

// TODO
public class XmlOutputStream extends OutputStream implements XmlStream{
	private OutputStream stream;
	private Hashtable table = new Hashtable();
/**
 * XmlOutputStream constructor comment.
 */
public XmlOutputStream(OutputStream s) {
	super();
	stream = s;
}
/**
 *
 */
private void _writeXmlAttribute(String name,String value) throws IOException
{
	Object entry = table.get( name );

	write( START_TAG );

	if(entry==null)
	{
		table.put( name,new Integer(table.size()) );
		System.out.println("Entry:"+name+" added to Output table");
		write( name );
	}
	else
	{
		write( REF );
		write( ((Integer)entry).byteValue() );
	}

	write("=\""+value+"\"");
}
/**
 *
 */
private void _writeXmlElement(XmlElement data) throws IOException
{
	Object entry = table.get( data.getName() );

	write( START_TAG );

	if(entry==null)
	{
		table.put( data.getName(),new Integer(table.size()) );
		System.out.println("Entry:"+data.getName()+" added to Output table");
		write( data.getName() );
	}
	else
	{
		write( REF );
		write( ((Integer)entry).byteValue() );
	}

	for(int loop=0;loop<data.getAttributeCount();loop++)
	{
		if(loop>0)
			write( ' ' );

		_writeXmlAttribute( data.getAttributeNameByIndex(loop),data.getAttributeValueByIndex(loop) );
	}

	if(data.getElementCount()==0)
	{
		write( CLOSE_TAG );
		return ;
	}
	else
		write( END_TAG );

	for(int loop=0;loop<data.getElementCount();loop++)
	{
		Object element = data.getData(loop);
		if(element instanceof XmlElement)
		{
			_writeXmlElement( (XmlElement)element );
		}
		else if(element instanceof String)
		{
			write( (String)element );
		}
	}

	write( CLOSE_TAG );
}
/**
 *
 */
public void flush() throws IOException
{
	stream.flush();
}
/**
 * write method comment.
 */
public void write(int b) throws IOException
{
	stream.write(b);
}
/**
 * write method comment.
 */
public void write(String s) throws IOException
{
	for(int loop=0;loop<s.length();loop++)
	{
		stream.write( s.charAt(loop) );
	}
}
/**
 *
 */
public void writeXmlElement(XmlElement data) throws IOException
{
	Object entry = table.get( data.getName() );

	write( START_TAG );

	if(entry==null)
	{
		table.put( data.getName(),new Integer(table.size()) );
		System.out.println("Entry:"+data.getName()+" added to Output table");
		write( data.getName() );
	}
	else
	{
		write( REF );
		write( ((Integer)entry).byteValue() );
	}

	for(int loop=0;loop<data.getAttributeCount();loop++)
	{
		if(loop>0)
			write( ' ' );

		_writeXmlAttribute( data.getAttributeNameByIndex(loop),data.getAttributeValueByIndex(loop) );
	}

	if(data.getElementCount()==0)
	{
		write( CLOSE_TAG );
		return ;
	}
	else
		write( END_TAG );

	for(int loop=0;loop<data.getElementCount();loop++)
	{
		Object element = data.getData(loop);
		if(element instanceof XmlElement)
		{
			_writeXmlElement( (XmlElement)element );
		}
		else if(element instanceof String)
		{
			write( (String)element );
		}
	}

	write( CLOSE_TAG );

	flush();
}
}
