package test.org.one.stone.soup.xml.helper;

import java.util.*;
import java.lang.reflect.*;

import org.one.stone.soup.xml.*;
import org.one.stone.soup.stringhelper.*;

/*
 * Wet-Wired.com Xml Helpers Version Date 25-Aug-2004
 *
 * Copyright 2000-2001 by Wet-Wired.com Ltd.,
 * Portsmouth England
 * This software is OSI Certified Open Source Software
 * This software is covered by an OSI approved open source licence
 * which can be found at http://www.onestonesoup.org/OSSLicense.html
 */

/**
 * @author nikcross
 *
 */

// TODO
public class XmlHelper {
private XmlHelper() {
	super();
}
public static Object getElementAsClassInstance(XmlElement element, String name)
throws
	ClassNotFoundException,
	InstantiationException,
	IllegalAccessException
{

	String className = element.getElementByName(name).getValue(0);

	Class clazz = Class.forName(className);

	Object instance = clazz.newInstance();

	return instance;
}
public static Object getElementAsClassInstance(XmlElement element, String name, String args[])
throws
	ClassNotFoundException,
	InstantiationException,
	NoSuchMethodException,
	IllegalAccessException,
	InvocationTargetException
{

	String className = element.getElementByName(name).getValue(0);

	Class clazz = Class.forName(className);

	Object instance = clazz.getConstructor(
		new Class[]{ Class.forName("[Ljava.lang.String;") }
			).newInstance(
					new Object[]{ args }
				);

	return instance;
}
public static int getElementAsInt(XmlElement element, String name) {
	return Integer.parseInt( element.getElementByName(name).getValue(0) );
}
public static String getElementAsString(XmlElement element, String name) {
	return element.getElementByName(name).getValue(0);
}
public static String[] getElementAsStringArray(XmlElement element, String name) {
	Vector data = (Vector)element.getElementByName(name).getData(0);

	return StringArrayHelper.vectorToStringArray(data);
}

public static Hashtable getElementAsHashtable(XmlElement element,String keyAttribute) {
	Hashtable table = new Hashtable();
	
	for(int loop=0;loop<element.getElementCount();loop++)
	{
		XmlElement item = element.getElementByIndex(loop);
		table.put(item.getAttributeValueByName(keyAttribute),item.getValue());
	}

	return table;
}

public static Hashtable getElementAsHashtable(XmlElement element) {
	Hashtable table = new Hashtable();
	
	for(int loop=0;loop<element.getElementCount();loop++)
	{
		XmlElement item = element.getElementByIndex(loop);
		table.put(item.getName(),item.getValue());
	}

	return table;
}

public static XmlElement getHashtableAsElement(String name,Hashtable table) {
	XmlElement element = new XmlElement(name);
	
	Enumeration enumeration = table.keys();
	while(enumeration.hasMoreElements())
	{
		String key = (String)enumeration.nextElement();
		XmlElement item = element.addChild("item");
		item.addAttribute("key",key);
		item.addDataItem( table.get(key) );
	}

	return element;
}
}
